package com.szyd.setting;


import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.szyd.uhfdemo.R;
import com.szyd.util.MUtil;

/**
 * A simple {@link Fragment} subclass.
 */
public class QRCodeFragment extends Fragment implements View.OnClickListener {

    private TextView showQRCodeStr;

    private IntentFilter intentFilter;
    private BroadcastReceiver scanReceiver;
    private final String RES_ACTION = "android.intent.action.SCANRESULT";

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View v = inflater.inflate(R.layout.fragment_qrcode, container, false);
        showQRCodeStr = v.findViewById(R.id.showQRCodeString);
        v.findViewById(R.id.startScanner).setOnClickListener(this);
        v.findViewById(R.id.stopScanner).setOnClickListener(this);
        initScanner();
        return v;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        getActivity().unregisterReceiver(scanReceiver);
    }

    private void initScanner() {
        intentFilter = new IntentFilter();
        intentFilter.addAction(RES_ACTION);
        //Register the broadcast receiver
        scanReceiver = new ScannerResultReceiver();
        getActivity().registerReceiver(scanReceiver, intentFilter);
    }

    @Override
    public void onClick(View v) {
        String operate = null;
        switch (v.getId()) {
            case R.id.startScanner:
                operate = "down";
                break;
            case R.id.stopScanner:
                operate = "up";
                break;
        }
        Intent localIntent = new Intent("com.idatachina.SCANKEYEVENT");
        localIntent.setPackage("com.android.auto.iscan");
        localIntent.putExtra("code", "188");
        localIntent.putExtra("action", operate);
        getActivity().sendOrderedBroadcast(localIntent, null);
    }

    /**
     * Scanning result will be broadcast
     */
    private class ScannerResultReceiver extends BroadcastReceiver {
        public void onReceive(Context context, Intent intent) {
            final String scanResult = intent.getStringExtra("value");
            /** if the length of barcode>0，decoding succeed; if the length of barcode =0,decoding failed.*/
            if (intent.getAction().equals(RES_ACTION)) {
                //To get the scanning result
                if (scanResult.length() > 0) {
                    showQRCodeStr.setText("Barcode：" + scanResult);
                } else {//else if(scanResult.length()==0)
                    /**There are two conditions for the use of the scan failure prompt:
                     1.The scan failure prompt interface needs to be called firstly, it is only available for the broadcast mode.
                     2.The decoding result depends on the barcode length. When the barcode length is equal to 0, decoding fails.
                     */
                    MUtil.show("Decoding failed!");
                }
            }
        }
    }
}
